----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:34:41 05/10/2006 
-- Design Name: 
-- Module Name:    SDIO - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity SDIO2 is
    Port ( h_clk : in  STD_LOGIC;
           h1_cmd : inout  STD_LOGIC;
           h1_dat3 : inout  STD_LOGIC;
           h1_dat2 : inout  STD_LOGIC;
           h1_dat1 : inout  STD_LOGIC;
           h1_dat0 : inout  STD_LOGIC;
			c1_clk : out  STD_LOGIC;
           c1_cmd : inout  STD_LOGIC;
           c1_dat3 : inout  STD_LOGIC;
           c1_dat2 : inout  STD_LOGIC;
           c1_dat1 : inout  STD_LOGIC;
           c1_dat0 : inout  STD_LOGIC;
		   --
		   h2_cmd : inout  STD_LOGIC;
           h2_dat3 : inout  STD_LOGIC;
           h2_dat2 : inout  STD_LOGIC;
           h2_dat1 : inout  STD_LOGIC;
           h2_dat0 : inout  STD_LOGIC;
			c2_clk : out  STD_LOGIC;
           c2_cmd : inout  STD_LOGIC;
           c2_dat3 : inout  STD_LOGIC;
           c2_dat2 : inout  STD_LOGIC;
           c2_dat1 : inout  STD_LOGIC;
           c2_dat0 : inout  STD_LOGIC;
			sel : in STD_LOGIC
			--test : in STD_LOGIC --simulation purpose only
			);
			  attribute KEEP: string;
end SDIO2;

architecture Behavioral of SDIO2 is
signal test: std_logic;


signal h1_cmd_oe, h1_cmd_reg, h1_cmd_clk, h1_cmd_buf, h1_cmd_reset: std_logic;
signal c1_cmd_oe, c1_cmd_reg, c1_cmd_clk, c1_cmd_buf, c1_cmd_reset: std_logic;
attribute KEEP of h1_cmd_buf: signal is "TRUE";
attribute KEEP of c1_cmd_buf: signal is "TRUE";

signal h1_dat3_oe, h1_dat3_reg, h1_dat3_clk, h1_dat3_reset: std_logic;
signal c1_dat3_oe, c1_dat3_reg, c1_dat3_clk, c1_dat3_reset: std_logic;

signal h1_dat2_oe: std_logic;
signal c1_dat2_oe: std_logic;

signal h1_dat1_oe: std_logic;
signal c1_dat1_oe: std_logic;

signal h1_dat0_oe: std_logic;
signal c1_dat0_oe: std_logic;

------

signal h2_cmd_oe, h2_cmd_reg, h2_cmd_clk, h2_cmd_buf, h2_cmd_reset: std_logic;
signal c2_cmd_oe, c2_cmd_reg, c2_cmd_clk, c2_cmd_buf, c2_cmd_reset: std_logic;
attribute KEEP of h2_cmd_buf: signal is "TRUE";
attribute KEEP of c2_cmd_buf: signal is "TRUE";

signal h2_dat3_oe, h2_dat3_reg, h2_dat3_clk, h2_dat3_reset: std_logic;
signal c2_dat3_oe, c2_dat3_reg, c2_dat3_clk, c2_dat3_reset: std_logic;

signal h2_dat2_oe: std_logic;
signal c2_dat2_oe: std_logic;

signal h2_dat1_oe: std_logic;
signal c2_dat1_oe: std_logic;

signal h2_dat0_oe: std_logic;
signal c2_dat0_oe: std_logic;

begin

test <= '0';

c1_clk <= h_clk and not sel;

-- 
h1_cmd_oe <= not h1_cmd_reg and not c1_cmd and not test and not sel;
h1_cmd <= '0' when (h1_cmd_oe = '1') else 'Z';
h1_cmd_clk <= not h1_cmd_reg and not c1_cmd_reg and not h1_cmd_buf;
h1_cmd_reset <= h1_cmd and c1_cmd;

h1_cmd_inst : buf
port map(
	O => h1_cmd_buf,
	I => h1_cmd
	);

process(h1_cmd_clk, h1_cmd_reset)
begin
	if(h1_cmd_reset = '1') then
		h1_cmd_reg <= '0';
	elsif(h1_cmd_clk'event and h1_cmd_clk = '1') then
		h1_cmd_reg <= '1';
	end if;
end process;

-- 
c1_cmd_oe <= not c1_cmd_reg and not h1_cmd and not test and not sel;
c1_cmd <= '0' when (c1_cmd_oe = '1') else 'Z';
c1_cmd_clk <= not c1_cmd_reg and not h1_cmd_reg and not c1_cmd_buf;
c1_cmd_reset <= c1_cmd and h1_cmd;

c1_cmd_inst : buf
port map(
	O => c1_cmd_buf,
	I => c1_cmd
	);

process(c1_cmd_clk, c1_cmd_reset)
begin
	if(c1_cmd_reset = '1') then
		c1_cmd_reg <= '0';
	elsif(c1_cmd_clk'event and c1_cmd_clk = '1') then
		c1_cmd_reg <= '1';
	end if;
end process;


-- 
h1_dat3_oe <= not h1_dat3_reg and not c1_dat3 and not test and not sel;
h1_dat3 <= '0' when (h1_dat3_oe = '1') else 'Z';
h1_dat3_clk <= not h1_dat3_reg and not c1_dat3_reg and ((not h1_dat3) or (not h1_dat2) or (not h1_dat1) or (not h1_dat0));
h1_dat3_reset <= h1_dat3 and c1_dat3 and h1_dat2 and c1_dat2 and h1_dat1 and c1_dat1 and h1_dat0 and c1_dat0;

process(h1_dat3_clk, h1_dat3_reset)
begin
	if(h1_dat3_reset = '1') then
		h1_dat3_reg <= '0';
	elsif(h1_dat3_clk'event and h1_dat3_clk = '1') then
		h1_dat3_reg <= '1';
	end if;
end process;

-- 
c1_dat3_oe <= not c1_dat3_reg and not h1_dat3 and not test and not sel;
c1_dat3 <= '0' when (c1_dat3_oe = '1') else 'Z';
c1_dat3_clk <= not c1_dat3_reg and not h1_dat3_reg and ((not c1_dat3) or (not c1_dat2) or (not c1_dat1) or (not c1_dat0));
c1_dat3_reset <= h1_dat3 and c1_dat3 and h1_dat2 and c1_dat2 and h1_dat1 and c1_dat1 and h1_dat0 and c1_dat0;

process(c1_dat3_clk, c1_dat3_reset)
begin
	if(c1_dat3_reset = '1') then
		c1_dat3_reg <= '0';
	elsif(c1_dat3_clk'event and c1_dat3_clk = '1') then
		c1_dat3_reg <= '1';
	end if;
end process;


-- 
h1_dat2_oe <= not h1_dat3_reg and not c1_dat2 and not test and not sel;
h1_dat2 <= '0' when (h1_dat2_oe = '1') else 'Z';

-- 
c1_dat2_oe <= not c1_dat3_reg and not h1_dat2 and not test and not sel;
c1_dat2 <= '0' when (c1_dat2_oe = '1') else 'Z';

-- 
h1_dat1_oe <= not h1_dat3_reg and not c1_dat1 and not test and not sel;
h1_dat1 <= '0' when (h1_dat1_oe = '1') else 'Z';

-- 
c1_dat1_oe <= not c1_dat3_reg and not h1_dat1 and not test and not sel;
c1_dat1 <= '0' when (c1_dat1_oe = '1') else 'Z';


-- 
h1_dat0_oe <= not h1_dat3_reg and not c1_dat0 and not test and not sel;
h1_dat0 <= '0' when (h1_dat0_oe = '1') else 'Z';

-- 
c1_dat0_oe <= not c1_dat3_reg and not h1_dat0 and not test and not sel;
c1_dat0 <= '0' when (c1_dat0_oe = '1') else 'Z';


-----------

c2_clk <= h_clk and sel;

-- 
h2_cmd_oe <= not h2_cmd_reg and not c2_cmd and not test and sel;
h2_cmd <= '0' when (h2_cmd_oe = '1') else 'Z';
h2_cmd_clk <= not h2_cmd_reg and not c2_cmd_reg and not h2_cmd_buf;
h2_cmd_reset <= h2_cmd and c2_cmd;

h2_cmd_inst : buf
port map(
	O => h2_cmd_buf,
	I => h2_cmd
	);

process(h2_cmd_clk, h2_cmd_reset)
begin
	if(h2_cmd_reset = '1') then
		h2_cmd_reg <= '0';
	elsif(h2_cmd_clk'event and h2_cmd_clk = '1') then
		h2_cmd_reg <= '1';
	end if;
end process;

-- 
c2_cmd_oe <= not c2_cmd_reg and not h2_cmd and not test and sel;
c2_cmd <= '0' when (c2_cmd_oe = '1') else 'Z';
c2_cmd_clk <= not c2_cmd_reg and not h2_cmd_reg and not c2_cmd_buf;
c2_cmd_reset <= c2_cmd and h2_cmd;

c2_cmd_inst : buf
port map(
	O => c2_cmd_buf,
	I => c2_cmd
	);

process(c2_cmd_clk, c2_cmd_reset)
begin
	if(c2_cmd_reset = '1') then
		c2_cmd_reg <= '0';
	elsif(c2_cmd_clk'event and c2_cmd_clk = '1') then
		c2_cmd_reg <= '1';
	end if;
end process;


-- 
h2_dat3_oe <= not h2_dat3_reg and not c2_dat3 and not test and sel;
h2_dat3 <= '0' when (h2_dat3_oe = '1') else 'Z';
h2_dat3_clk <= not h2_dat3_reg and not c2_dat3_reg and ((not h2_dat3) or (not h2_dat2) or (not h2_dat1) or (not h2_dat0));
h2_dat3_reset <= h2_dat3 and c2_dat3 and h2_dat2 and c2_dat2 and h2_dat1 and c2_dat1 and h2_dat0 and c2_dat0;

process(h2_dat3_clk, h2_dat3_reset)
begin
	if(h2_dat3_reset = '1') then
		h2_dat3_reg <= '0';
	elsif(h2_dat3_clk'event and h2_dat3_clk = '1') then
		h2_dat3_reg <= '1';
	end if;
end process;

-- 
c2_dat3_oe <= not c2_dat3_reg and not h2_dat3 and not test and sel;
c2_dat3 <= '0' when (c2_dat3_oe = '1') else 'Z';
c2_dat3_clk <= not c2_dat3_reg and not h2_dat3_reg and ((not c2_dat3) or (not c2_dat2) or (not c2_dat1) or (not c2_dat0));
c2_dat3_reset <= h2_dat3 and c2_dat3 and h2_dat2 and c2_dat2 and h2_dat1 and c2_dat1 and h2_dat0 and c2_dat0;

process(c2_dat3_clk, c2_dat3_reset)
begin
	if(c2_dat3_reset = '1') then
		c2_dat3_reg <= '0';
	elsif(c2_dat3_clk'event and c2_dat3_clk = '1') then
		c2_dat3_reg <= '1';
	end if;
end process;


-- 
h2_dat2_oe <= not h2_dat3_reg and not c2_dat2 and not test and sel;
h2_dat2 <= '0' when (h2_dat2_oe = '1') else 'Z';

-- 
c2_dat2_oe <= not c2_dat3_reg and not h2_dat2 and not test and sel;
c2_dat2 <= '0' when (c2_dat2_oe = '1') else 'Z';

-- 
h2_dat1_oe <= not h2_dat3_reg and not c2_dat1 and not test and sel;
h2_dat1 <= '0' when (h2_dat1_oe = '1') else 'Z';

-- 
c2_dat1_oe <= not c2_dat3_reg and not h2_dat1 and not test and sel;
c2_dat1 <= '0' when (c2_dat1_oe = '1') else 'Z';


-- 
h2_dat0_oe <= not h2_dat3_reg and not c2_dat0 and not test and sel;
h2_dat0 <= '0' when (h2_dat0_oe = '1') else 'Z';

-- 
c2_dat0_oe <= not c2_dat3_reg and not h2_dat0 and not test and sel;
c2_dat0 <= '0' when (c2_dat0_oe = '1') else 'Z';


end Behavioral;

